<template>
  <transition
    name="expand"
    :data-qa="dataQa"
    @enter="enter"
    @after-enter="afterEnter"
    @after-leave="$emit('on-end-transition')"
    @leave="leave"
  >
    <slot />
  </transition>
</template>

<script>
export default {
  props: {
    dataQa: {
      type: String
    }
  },
  methods: {
    enter (el) {
      const width = getComputedStyle(el).width
      el.style.width = width
      el.style.position = 'absolute'
      el.style.visibility = 'hidden'
      el.style.height = 'auto'

      const height = getComputedStyle(el).height

      el.style.width = null
      el.style.position = null
      el.style.visibility = null
      el.style.height = 0

      setTimeout(() => {
        el.style.height = height
      })
    },

    afterEnter (el) {
      el.style.height = 'auto'
      this.$emit('on-end-transition')
    },

    leave (el) {
      const height = getComputedStyle(el).height
      el.style.height = height

      setTimeout(() => {
        el.style.height = 0
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.expand-enter-active,
.expand-leave-active {
  transition: height 0.3s ease-in-out;
  overflow: hidden;
}

.expand-enter,
.expand-leave-to {
  height: 0;
}
</style>
